/*
 * GTI (Generic Tools Infrastructure)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2015
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2015
 * Copyright (C) RWTH Aachen University, Federal Republic of Germany, 2013-2015
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file PanicFilter.h
 *       @see MUST::PanicFilter.
 *
 *  @date 11.07.2012
 *  @author Tobias Hilbrich, Joachim Protze, Mathias Korepkat
 */

#include "ModuleBase.h"

#include "I_PanicFilter.h"

#ifndef PANICFILTER_H
#define PANICFILTER_H

namespace gti
{
    /**
     * Implementation of I_PanicFilter.
     */
    class PanicFilter : public ModuleBase<PanicFilter, I_PanicFilter>
    {
    public:
        /**
         * Constructor.
         * @param instanceName name of this module instance.
         */
        PanicFilter (const char* instanceName);

        /**
         * Destructor.
         */
        virtual ~PanicFilter (void);

        /**
         * @see I_PanicFilter::propagate
         */
        GTI_ANALYSIS_RETURN propagate (
                gti::I_ChannelId *thisChannel,
                std::list<gti::I_ChannelId*> *outFinishedChannels);

        /**
         * The timeout function, see gti::I_Reduction.timeout
         */
        void timeout (void);

    protected:
        bool myHadPanic;
    };
} /*namespace gti*/

#endif /*PANICFILTER_H*/
