/*
 * GTI (Generic Tools Infrastructure)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2015
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2015
 * Copyright (C) RWTH Aachen University, Federal Republic of Germany, 2013-2015
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file PanicHandler.h
 *       @see MUST::PanicHandler.
 *
 *  @date 11.07.2012
 *  @author Tobias Hilbrich, Joachim Protze, Mathias Korepkat
 */

#include "ModuleBase.h"

#include "I_PanicHandler.h"

#ifndef PANICHANDLER_H
#define PANICHANDLER_H

namespace gti
{
    /**
     * Implementation of I_PanicHandler.
     */
    class PanicHandler : public ModuleBase<PanicHandler, I_PanicHandler>
    {
    public:
        /**
         * Constructor.
         * @param instanceName name of this module instance.
         */
        PanicHandler (const char* instanceName);

        /**
         * Destructor.
         */
        virtual ~PanicHandler (void);

        /**
         * @see I_PanicHandler::raisePanic
         */
        GTI_ANALYSIS_RETURN raisePanic (void);

    protected:
        bool myHadPanic;
    };
} /*namespace gti*/

#endif /*PANICHANDLER_H*/
