/*
 * GTI (Generic Tools Infrastructure)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2015
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2015
 * Copyright (C) RWTH Aachen University, Federal Republic of Germany, 2013-2015
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file ShutdownHandler.h
 *       @see MUST::ShutdownHandler.
 *
 *  @date 27.06.2012
 *  @author Tobias Hilbrich, Joachim Protze, Mathias Korepkat
 */

#include "ModuleBase.h"

#include "I_ShutdownHandler.h"

#ifndef SHUTDOWNHANDLER_H
#define SHUTDOWNHANDLER_H

namespace gti
{
    /**
     * Implementation of I_ShutdownHandler.
     */
    class ShutdownHandler : public ModuleBase<ShutdownHandler, I_ShutdownHandler>
    {
    public:
        /**
         * Constructor.
         * @param instanceName name of this module instance.
         */
        ShutdownHandler (const char* instanceName);

        /**
         * Destructor.
         */
        virtual ~ShutdownHandler (void);

        /**
         * @see I_ShutdownHandler::notifyShutdown.
         */
        GTI_ANALYSIS_RETURN notifyShutdown (gti::I_ChannelId* channelId);

    protected:

    };
} /*namespace gti*/

#endif /*SHUTDOWNHANDLER_H*/
