/*
 * GTI (Generic Tools Infrastructure)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2015
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2015
 * Copyright (C) RWTH Aachen University, Federal Republic of Germany, 2013-2015
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file ShutdownReceiver.h
 *       @see MUST::ShutdownReceiver.
 *
 *  @date 27.06.2012
 *  @author Tobias Hilbrich, Joachim Protze, Mathias Korepkat
 */

#include "ModuleBase.h"

#include "I_ShutdownReceiver.h"

#ifndef SHUTDOWNRECEIVER_H
#define SHUTDOWNRECEIVER_H

namespace gti
{
    /**
     * Implementation of I_ShutdownReceiver.
     */
    class ShutdownReceiver : public ModuleBase<ShutdownReceiver, I_ShutdownReceiver>
    {
    public:
        /**
         * Constructor.
         * @param instanceName name of this module instance.
         */
        ShutdownReceiver (const char* instanceName);

        /**
         * Destructor.
         */
        virtual ~ShutdownReceiver (void);

        /**
         * @see I_ShutdownReceiver::receive
         */
        GTI_ANALYSIS_RETURN receive (void);

    protected:
    };
} /*namespace gti*/

#endif /*SHUTDOWNRECEIVER_H*/
