/*
 * GTI (Generic Tool Infrastructure)
 * Copyright (C)
 *  2011-2015 ZIH, Technische Universitaet Dresden, Federal Republic of Germany
 *  2011-2015 Lawrence Livermore National Laboratories, United States of America
 *  2013-2015 RWTH Aachen University, Federal Republic of Germany
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file Mpize.h
 *  Calls MPI_Init and MPI_Finalize in applications that
 *  do not utilize MPI, to establish the basic GTI communication
 *  network.
 * 
 *
 * @author Felix Münchhalfen
 * @date 09.07.2014
 *
 */

#ifndef MPIZE_H
#define	MPIZE_H

/**
 * This class uses the C++ global constructor/destructor
 * mechanism to initialize/finalize when this .so gets
 * loaded or closed.
 */
class Mpize {
    
private:
    static int initialized;
    
    void read_cmdline( int *argc, char ***argv );
public:
    Mpize();
    ~Mpize();
    void Init();
};

#endif	/* MPIZE_H */

