#include <assert.h>
#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <iostream>
#include <fstream>

struct timeval gStart, gEnd;

extern "C" int MPI_Init(int * argc, char *** argv)
{
  gettimeofday(&gStart, NULL);
  int err = PMPI_Init(argc, argv);
  assert (err == MPI_SUCCESS);
  return err;
}

extern "C" int MPI_Finalize()
{
  int err,rank;
  gettimeofday(&gEnd, NULL);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  if (rank == 0)
  {
     std::ofstream timeFile ("GTI_FinalizeTiminig.txt");
     timeFile << "Time Pre Init - Pre Finalize of Tool " << rank << " (usec): " << ((gEnd.tv_sec * 1000000 + gEnd.tv_usec) - (gStart.tv_sec * 1000000 + gStart.tv_usec)) << std::endl;
  }

  PMPI_Barrier(MPI_COMM_WORLD);
  err=PMPI_Finalize();
//   exit(0);
  return err;
}
