/*
 * GTI (Generic Tool Infrastructure)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2010-2015
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2010-2015
 * Copyright (C) RWTH Aachen University, Federal Republic of Germany, 2013-2015
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file PrintFloatSum.h
 *       Interface for the reduction example print module.
 *
 *  @date 23.12.2010
 *  @author Tobias Hilbrich
 */

#include "I_Module.h"
#include "GtiEnums.h"
#include "I_ChannelId.h"

#ifndef PRINTFLOATSUM_H
#define PRINTFLOATSUM_H

/** PrintFloatSum interface. */
class I_PrintFloatSum : public gti::I_Module
{
public:
	/** Performs the printing. */
    virtual gti::GTI_ANALYSIS_RETURN print (float f, gti::I_ChannelId* id) = 0;
}; /*class I_PrintFloatSum*/

#endif /*PRINTFLOATSUM_H*/
