/*
 * GTI (Generic Tool Infrastructure)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2010-2015
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2010-2015
 * Copyright (C) RWTH Aachen University, Federal Republic of Germany, 2013-2015
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file SumFloatReduction.h
 *       Interface for the reduction of a reduction example.
 *
 *  @date 23.12.2010
 *  @author Tobias Hilbrich
 */

#include "I_Module.h"
#include "I_Reduction.h"
#include "I_ChannelId.h"
#include "GtiEnums.h"

#include <list>

#ifndef SUMFLOATREDUCTION_H
#define SUMFLOATREDUCTION_H

/** SummAllFloats interface. */
class I_SumFloatReduction : public gti::I_Module, public gti::I_Reduction
{
public:
	/** Performs the reduction. */
    virtual gti::GTI_ANALYSIS_RETURN reduce (float f, gti::I_ChannelId *thisChannel, std::list<gti::I_ChannelId*> *outFinishedChannels) = 0;
}; /*class I_SumFloatReduction*/

#endif /*SUMFLOATREDUCTION_H*/
